package com.kawanansemut.demoangular

import com.kawanansemut.demoangular.entities.User
import com.kawanansemut.demoangular.entities.UserRepository
import org.springframework.web.bind.annotation.*

@RestController
class UserController (val userRepository:UserRepository){
    @GetMapping("/user")
    fun getAllUser():Iterable<User>{
        return userRepository.findAll()
    }

    @GetMapping("/user/{id}")
    fun getOneUser(@PathVariable("id") id:Long):User{
        return userRepository.findById(id).orElseThrow()
    }

    @PostMapping("/user")
    fun addUser(@RequestBody user:User):User{
        return userRepository.save(user)
    }

    @PutMapping("/user/{id}")
    fun updateUser(@RequestBody user:User,@PathVariable("id") id:Long):User{
        var u = userRepository.findById(id).orElseThrow()
        u.username = user.username
        u.password = user.password
        u.fullname = user.fullname

        return userRepository.save(u)
    }

    @DeleteMapping("/user/{id}")
    fun deleteUSer(@PathVariable("id") id:Long){
        userRepository.delete(userRepository.findById(id).orElseThrow())
    }
}